11.20.3   os32: proc_init(9)

NOME

    proc_init - inizializzazione della gestione complessiva dei processi
    elaborativi

SINTASSI

    <kernel/proc.h>
    extern uint32_t <_k_start>;
    extern uint32_t <_k_end>;
    extern uint32_t <_k_text_end>;
    extern uint32_t <_k_data_end>;
    extern uint32_t <_k_bss_end>;
    extern uint32_t <_k_stack_top>;
    extern uint32_t <_k_stack_bottom>;
    void proc_init (void);

ARGOMENTI

    Argomento                          Descrizione
                                       La variabile <_k_start> viene fornita
    extern uint32_t <_k_start>;        dal file di configurazione kernel.ld e
                                       rappresenta l'indirizzo iniziale del
                                       kernel.
                                       La variabile <_k_end> viene fornita dal
    extern uint32_t <_k_end>;          file di configurazione kernel.ld e
                                       rappresenta l'indirizzo finale del
                                       kernel, dati e pila inclusi.
                                       La variabile <_k_text_end> viene fornita
    extern uint32_t <_k_text_end>;     dal file di configurazione kernel.ld e
                                       rappresenta l'indirizzo finale del
                                       codice del kernel.
                                       La variabile <_k_data_end> viene fornita
    extern uint32_t <_k_data_end>;     dal file di configurazione kernel.ld e
                                       rappresenta l'indirizzo finale dei dati
                                       kernel, esclusa pero` l'area BSS e la
                                       pila.
                                       La variabile <_k_bss_end> viene fornita
    extern uint32_t <_k_bss_end>;      dal file di configurazione kernel.ld e
                                       rappresenta l'indirizzo finale dell'area
                                       BSS del kernel, ma coincide con
                                       <_k_end>.
                                       La variabile <_k_stack_top> viene
    extern uint32_t <_k_stack_top>;    fornita dal file kernel/main/stack.s e
                                       rappresenta l'indirizzo iniziale della
                                       pila dei dati del kernel.
                                       La variabile <_k_stack_bottom> viene
    extern uint32_t <_k_stack_bottom>; fornita dal file kernel/main/stack.s e
                                       rappresenta l'indirizzo finale della
                                       pila dei dati del kernel.

DESCRIZIONE

    La funzione <proc_init()> viene usata una volta sola, dalla funzione kmain
    (9) [11.13], per predisporre la gestione dei processi. Per la precisione si
    occupa di:

      □ predisporre la tabella GDT, attraverso la chiamata della funzione <gdt
        ()>;

      □ impostare il temporizzatore in modo da fornire impulsi alla frequenza
        dichiarata nella macro-variabile <CLOCKS_PER_SEC>, pari a 100 Hz;

      □ predisporre la tabella IDT, attraverso la chiamata della funzione <idt
        ()>;

      □ azzerare la tabella dei processi, inserendovi pero` i dati relativi al
        kernel (il processo zero);

      □ allocare la memoria gia` utilizzata dal kernel;

      □ attivare selettivamente le interruzioni hardware desiderate;

      □ attivare la gestione delle unita` PATA;

      □ innestare il file system principale.

FILE SORGENTI

    kernel/proc.h [12.14]

    kernel/proc/proc_public.c [12.14.5]

    kernel/proc/proc_init.c [12.14.3]

VEDERE ANCHE

    proc_available(9) [11.20.1], sb_mount(9) [11.6.27].

